-- We can't NetVar a function so we need a way to identify it by name
rawset(_G, "ww_afterfuncs", ww_afterfuncs or {})

local after = {}

-- mmm not sure if i need better namespace here, and not "WarioWare"
rawset(_G, "WW_DoAfter", function(name, tics)
	table.insert(after, {name = name, tics = tics})
end)

addHook("MapLoad", function()
	after = {}
end)

addHook("NetVars", function(net)
	after = net($)
end)

addHook("ThinkFrame", function()
	if leveltime == 0 then return end -- Cursed

	for i = #after, 1, -1 do
		after[i].tics = $ - 1
		
		if after[i].tics <= 0 then
			local func = ww_afterfuncs[after[i].name]

			if func then func() end

			table.remove(after, i)
		end
	end
end)