-- Minigames manager

-- list of tags that will warp to a regular minigame
local GAMES_NORMAL = {
	1001,
	1002,
	1003,
	1004,
	1005,
	1006,
	1007,
	1008,
	1009,
	1010,
	1011,
	1012,
	1013,
	1014,
	1015,
	1016,
	1017,
	1018,
	1019,
	1021,
	1022,
	1023,
	1024,
	2000,
}

-- List of tags that will warp to a "boss" minigame
local GAMES_BOSS = {
	1027,
	1026,
	1020,
}

local NUMGAMES = 13

local games_to_play = {}

addHook("NetVars", function(net)
	games_to_play = net($)
end)

addHook("MapLoad", function(mapid)
	if G_BuildMapName(mapid) == "MAPWR" then
		games_to_play = {}
		
		-- table.remove pops in reverse order so we would have NUMGAMES-1 normal minigames and then 1 boss minigame
		table.insert(games_to_play, GAMES_BOSS[P_RandomRange(1, #GAMES_BOSS)])
		
		local copy = {}
		
		for i = 1, #GAMES_NORMAL do
			table.insert(copy, GAMES_NORMAL[i])
		end
		
		for i = 1, NUMGAMES-1 do
			table.insert(games_to_play, table.remove(copy, P_RandomRange(1, #copy)))
		end
	end
end)

WW_Event("WW_NEXTGAME", function()
	-- We played all minigames
	if #games_to_play == 0 then
		WW_EXIT()
		return
	end
	
	local choice = table.remove(games_to_play)
	
	P_LinedefExecute(choice, nil, nil)
end)