-- Scoring through changing color

local MINSPEED = 20*FRACUNIT

ww_afterfuncs["WW_COLOR"] = function()
	for player in players.iterate do
		if not (player.spectator or (player.ww_color == player.skincolor)) then
			WW_AddPoints(player, 1)
		end
	end
end

local function rainbow(str)
    local colors = {'\133', '\135', '\130', '\131', '\136', '\132', '\137'}
    local buff = {}
    local len = #str

    for i = 0, len-1 do
        table.insert(buff, colors[i % 7 + 1])
        table.insert(buff, str:sub(i+1, i+1))
    end

    return table.concat(buff, "")
end

WW_Event("WW_COLOR", function()
	for player in players.iterate do
		player.ww_color = player.skincolor
	end

	WW_DoAfter("WW_COLOR", 4*TICRATE)
	
	WW_InstructionAll("Change your "..rainbow("color!"))
end)