-- Eggman monitor

local active = false

WW_Event("WW_EGGMANSTART", function()
	local plist = {}

	for player in players.iterate do
		player.ww_washit = false
		player.ww_eggman = false
		
		if not player.spectator then table.insert(plist, player) end
	end
	
	if #plist < 2 then return end
	
	local eggman = plist[P_RandomRange(1, #plist)]
	
	eggman.ww_need_hit = 1
	eggman.ww_eggman = true
	eggman.kartstuff[k_itemroulette] = 1
	eggman.kartstuff[k_roulettetype] = 2
	eggman.kartstuff[k_eggmanblame] = #eggman
	
	
	WW_InstructionAll("Avoid the \133KAMIKAZE\128!")

	-- Will overwrite previous instruction for this player
	WW_Instruction(eggman, string.format("\133Explode\128 %d other %s!", eggman.ww_need_hit, eggman.ww_need_hit > 1 and "players" or "player"))
	
	active = true
end)

WW_Event("WW_EGGMANEND", function()
	active = false

	for player in players.iterate do
		if (player.ww_eggman and player.ww_need_hit == 0) or not (player.ww_eggman or player.ww_washit) then
			WW_AddPoints(player, 1)
		end
	end
end)

local function hit(player, _, inflictor)
	if not active then return end
	if player.ww_eggman then return end
	
	player.ww_washit = true
	
	if inflictor and inflictor.player and inflictor.player.ww_eggman and inflictor.player.ww_need_hit > 0 then
		inflictor.player.ww_need_hit = max($ - 1, 0)
		
		if inflictor.player.ww_need_hit == 0 then
			S_StartSound(nil, sfx_hidden, inflictor.player)
		end
	end
end

addHook("PlayerExplode", hit)

addHook("NetVars", function(net)
	active = net($)
end)