-- Grow

local active = false

WW_Event("WW_GROWSTART", function()
	local plist = {}

	for player in players.iterate do
		player.ww_washit = false
		player.ww_grow = false
		
		if not player.spectator then table.insert(plist, player) end
	end
	
	if #plist == 0 then return end

	local grow = plist[P_RandomRange(1, #plist)]

	grow.ww_grow = true
	grow.ww_need_hit = max(#plist / 5, 1)
	
	WW_InstructionAll("Don't get \132squished\128!")

	-- Will overwrite previous instruction for this player
	WW_Instruction(grow, string.format("\132Squish\128 %d other %s!", grow.ww_need_hit, grow.ww_need_hit > 1 and "players" or "player"))

	active = true
end)

WW_Event("WW_GROWEND", function()
	active = false

	for player in players.iterate do
		if (player.ww_grow and player.ww_need_hit == 0) or not (player.ww_grow or player.ww_washit) then
			WW_AddPoints(player, 1)
		end
	end
end)

addHook("ThinkFrame", function()
	if not active then return end
	
	for player in players.iterate do
		if player.mo and player.ww_grow then
			player.mo.destscale = 3*mapobjectscale/2
			player.kartstuff[k_growshrinktimer] = ((leveltime % 5) == 0) and 5 or 4 -- Hack to allow color blink animation
		elseif player.mo and player.ww_washit then
			player.kartstuff[k_hyudorotimer] = 2
		end
	end
end)

local function hit(player, _, inflictor)
	if not active then return end
	
	player.ww_washit = true

	if inflictor and inflictor.player and inflictor.player.ww_grow and inflictor.player.ww_need_hit > 0 then
		inflictor.player.ww_need_hit = max($ - 1, 0)
		
		local sfx = inflictor.player.ww_need_hit == 0 and sfx_hidden or sfx_hoop3
		
		S_StartSound(nil, sfx, inflictor.player)
	end
end

addHook("PlayerSquish", hit)

addHook("NetVars", function(net)
	active = net($)
end)