-- Scoring through hitting other players

local active = false

addHook("NetVars", function(net)
	active = net($)
end)

addHook("MapLoad", function()
	-- If WW_PVPEND wasn't called for some reason
	active = false
end)

WW_Event("WW_PVPSTART", function()
	active = true
	
	WW_InstructionAll("\131Hit\128 other players!")
end)

WW_Event("WW_PVPEND", function()
	active = false
end)

local function hit(player, _, inflictor)
	if not active then return end
	
	if inflictor and inflictor.player and inflictor.player ~= player then
		WW_AddPoints(inflictor.player, 1)
	end
end

addHook("PlayerSpin", hit)
addHook("PlayerExplode", hit)
addHook("PlayerSquish", hit)