-- Tag

local active = false
local starttime = 0

WW_Event("WW_TEAMTAGSTART", function()
	WW_AssignTeams()

	for player in players.iterate do
		player.ww_tag_done = false
	end

	active = true
	starttime = leveltime
	
	WW_InstructionTeam(WW_TEAM_BLUE, "Don't get caught by \133RED\128 players!")
	WW_InstructionTeam(WW_TEAM_RED, "Catch a \132BLUE\128 player!")
	
	for player in players.iterate do
		if player.ww_team == WW_TEAM_RED then
			player.kartstuff[k_itemtype] = KITEM_SNEAKER
			player.kartstuff[k_itemamount] = 1
			player.kartstuff[k_itemblinkmode] = 2
			player.kartstuff[k_itemblink] = TICRATE
			S_StartSound(nil, sfx_itrolk, player)
		end
	end
end)

WW_Event("WW_TEAMTAGEND", function()
	active = false

	local teamscores = {}

	for player in players.iterate do
		if player.ww_team == WW_TEAM_BLUE and not player.ww_tag_done then
			WW_AddPoints(player, 1)
		end
	end

	WW_ResetTeams()
end)

local function collide(pmo, pmo2)
	if not active then return end
	if leveltime - starttime < 2 then return end
	if not (pmo.valid and pmo2.valid) then return end
	if not pmo2.player then return end
	if pmo2.z+pmo2.height < pmo.z or pmo.z+pmo.height < pmo2.z then return end

	local p1, p2 = pmo.player, pmo2.player

	if p1.ww_tag_done or p2.ww_tag_done then return end

	if p1.ww_team ~= p2.ww_team then
		if p1.ww_team == WW_TEAM_RED then
			WW_AddPointsDelayed(p1, 1)
			S_StartSound(nil, sfx_s3k4e, p1)
			K_ExplodePlayer(p2, pmo, pmo)
		else
			WW_AddPointsDelayed(p2, 1)
			S_StartSound(nil, sfx_s3k4e, p2)
			K_ExplodePlayer(p1, pmo2, pmo2)
		end

		p1.ww_tag_done = true
		p2.ww_tag_done = true
	end
end

addHook("MobjCollide", collide, MT_PLAYER)
addHook("MobjMoveCollide", collide, MT_PLAYER)

addHook("ThinkFrame", function()
	if not active return end

	for player in players.iterate do
		if not player.spectator and player.ww_tag_done then
			player.kartstuff[k_hyudorotimer] = 4
		end
	end
end)

addHook("NetVars", function(net)
	active = net($)
	starttime = net($)
end)