-- Scoring via team battle

local active = false

WW_Event("WW_TEAMBATTLESTART", function()
	WW_AssignTeams()

	for player in players.iterate do
		player.ww_teamscore = 0
	end
	
	WW_InstructionTeam(WW_TEAM_BLUE, "Hurt \133RED\128 players!")
	WW_InstructionTeam(WW_TEAM_RED, "Hurt \132BLUE\128 players!")

	active = true
end)

WW_Event("WW_TEAMBATTLEEND", function()
	active = false

	local teamscores = {}

	for player in players.iterate do
		if player.ww_team ~= nil and not player.spectator then
			teamscores[player.ww_team] = ($ or 0) + (player.ww_teamscore or 0)
		end
	end

	if teamscores[WW_TEAM_BLUE] == teamscores[WW_TEAM_RED] then
		print("Tie! No one gets points")
	else
		local winner = teamscores[WW_TEAM_BLUE] > teamscores[WW_TEAM_RED] and WW_TEAM_BLUE or WW_TEAM_RED

		print("Team "..WW_TEAM_NAMES[winner].." wins!")

		WW_AddPointsTeam(winner, 1)
	end

	WW_ResetTeams()
end)

local function hit(player, _, inflictor)
	if not active then return end

	if inflictor and inflictor.player and (inflictor.player.ww_team ~= player.ww_team) then
		inflictor.player.ww_teamscore = ($ or 0) + 1
	end
end

-- TODO - maybe needs hud or smth

addHook("PlayerSpin", hit)
addHook("PlayerSquish", hit)
addHook("PlayerExplode", hit)

addHook("NetVars", function(net)
	active = net($)
end)